
<!doctype html>
<html >
<head id="ctl00_Head1"><meta charset="utf-8" /><title>
	TradingEconomics.com - Privacy Policy
</title><meta id="metaDesc" name="description" content="Trading Economics Privacy Policy" /><meta id="metaKeyword" name="keywords" /><meta name="viewport" content="width=device-width,minimum-scale=1,initial-scale=1" /><meta name="theme-color" content="#333333" /><meta property="fb:app_id" content="780337348699873" /><meta property="fb:admins" content="100008712870955" /><link rel="icon" href="https://d3fy651gv2fhd3.cloudfront.net/favicon.ico" /><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.2/css/bootstrap.min.css" /><link rel="stylesheet" href="/stylesheet.css?v=20180827" />
<script type="text/javascript">var TESymbol = ''; var TECountry = ''; var TECategory = ''; var TELanguage = ''; var symbol = ''; var symbolType = ''; var hasCalendar = false;</script>
<script type="text/javascript">if(!window.console){console={}; console.log = function(){}; console.dir = function(){}; console.error = function(){};console.info = function(){};console.warn = function(){};}</script>
<script data-schema="Organization" type="application/ld+json">{"@context":"http://schema.org","@type":"Organization","name":"TRADING ECONOMICS","url":"https://tradingeconomics.com","logo":"https://d3fy651gv2fhd3.cloudfront.net/images/logo.png?v=20171228","sameAs":["https://www.facebook.com/TradingEconomics","https://twitter.com/teconomics"],"contactPoint": {"@type": "ContactPoint","telephone": "+1-646-593-8917","contactType": "Customer service"}, "email": "support(at)tradingeconomics.com", "founders" : [{"@type":"Person", "familyName": "Sousa", "givenName": "Antonio"},{"@type":"Person", "familyName": "Fedec","givenName": "Anna"}],   "location": {"@type": "Place", "name": "Headquarters", "address": {"@type": "PostalAddress","addressLocality": "New York City","addressRegion": "NY"}},"legalName":"IECONOMICS INC", "naics": "518210"}</script>
<script data-schema='WebPage' type='application/ld+json'>{"url":"https://tradingeconomics.com/privacy-policy.aspx","@type":"WebPage","@context":"http://schema.org"}</script><link rel="canonical" href="https://tradingeconomics.com" /></head>
<body>
    <form method="post" action="privacy-policy.aspx" id="aspnetForm">
<div class="aspNetHidden">
<input type="hidden" name="__EVENTTARGET" id="__EVENTTARGET" value="" />
<input type="hidden" name="__EVENTARGUMENT" id="__EVENTARGUMENT" value="" />
<input type="hidden" name="__VIEWSTATE" id="__VIEWSTATE" value="NqxAzYN2828FJLdIacTD2H5U0IiXmUqDwQLnjatZPIdRGl/fkgC+egZxmlRfaTbRXmgOn6+ep+zsTIayf91R4H2uDGm0IhGzRUevi6wISvWG35bMVaTP/saNpMmz//tJF1uZP/3rMQwlG7eaYhD3lSjC4wS4x5i8mGvtgBfU3/q1EsI3" />
</div>

<script type="text/javascript">
//<![CDATA[
var theForm = document.forms['aspnetForm'];
if (!theForm) {
    theForm = document.aspnetForm;
}
function __doPostBack(eventTarget, eventArgument) {
    if (!theForm.onsubmit || (theForm.onsubmit() != false)) {
        theForm.__EVENTTARGET.value = eventTarget;
        theForm.__EVENTARGUMENT.value = eventArgument;
        theForm.submit();
    }
}
//]]>
</script>


<script src="/WebResource.axd?d=pynGkmcFUV13He1Qd6_TZBMhXpY-76SACKbmnGHSZE-ofY595en_c0qcOkCvri7A5kw1ug2&amp;t=635332691990365797" type="text/javascript"></script>


<script type="text/javascript">
//<![CDATA[
var isPostBack = false;//]]>
</script>

<script src="/ScriptResource.axd?d=qph9tUZ6hGPLbkznkRkqTYWzjMBsKlRyREi1YDjmYE3zZGh__TOd3PNxPEW8XfwkObfckMpB67GQVSJ51YrflW5zr1QyM_9-4d1Dx1U_ZJ94G98-0&amp;t=ffffffffda74082d" type="text/javascript"></script>
<script src="/ScriptResource.axd?d=TvpD2YGOOsCm1yWcLkKnBcOzd1_nGQYeeL4PwtDBt7imo7Xq206E1JCXpNIIAaBOvalbrcyjs3ojCjl9X73ADInNbjuzU-P1PNtDcnYLQlyvhD9N0&amp;t=ffffffffda74082d" type="text/javascript"></script>
<div class="aspNetHidden">

	<input type="hidden" name="__VIEWSTATEGENERATOR" id="__VIEWSTATEGENERATOR" value="2927320D" />
</div>
        <div class="container">
            <script type="text/javascript">
//<![CDATA[
Sys.WebForms.PageRequestManager._initialize('ctl00$AjaxScriptManager1$ScriptManager1', 'aspnetForm', [], [], [], 90, 'ctl00');
//]]>
</script>

            
<style>.nav-item{border-top:1px solid #ddd; padding-top: 5px;padding-bottom: 5px;} .nav-item:hover{background-color: #fafafa;}.nav-item>a {text-decoration: none;}</style>
<div id="ctl00_NavigationUC1_menu" class="navbar navbar-fixed-top navbar-default" role="navigation">
    <div class="container">    
        <div class="navbar-header" id="searchMobileHeader" style="display:none;height: 40px;">
            <a noref class="navbar-brand">
                <input type="text" placeholder="Search"
                                    id="thisIstheTinySearchBoxIdTag"
                                    autocomplete="off"
                                    class="nav-search-input-class"
                                   style="font-size: 1.1em; border: 0px; color: #333; border-bottom: 1px solid #858585; background-color: transparent;"/>
             </a>
            <ul id="thisIstheTinySearchResultsIdTag" class="dropdown-menu" style="position: fixed; width: 100%; top: 42px; border-top-color: #FFF; display:block;padding: 0;border: 0;">
                        <li>
                            <div class="container">
                                <div id="dpSearch-resultCnt-tiny" class="dpTaResult">
                                </div>
                            </div>
                        </li>
                    </ul>
            <div class="navbar-mobile-list pull-right hidden-sm hidden-md hidden-lg" style="padding-top: 10px;">
                <a noref class="navbar-mobile-item" id="thisIsTheTinyRemoveId"> <i class="glyphicon glyphicon-remove"></i> </a>
            </div>
        </div>
        
        <div class="navbar-header"  id="mainHeader">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                <span class="sr-only"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a class="navbar-brand" href="/">
                <span id="logo-title">TRADING</span><br />
                <span id="logo-subtitle">ECONOMICS</span>
            </a>
            <div class="navbar-mobile-list pull-right hidden-sm hidden-md hidden-lg" style="padding-top: 10px;">
                <a href="/calendar" class="navbar-mobile-item"><i class="glyphicon glyphicon-calendar"></i></a>
                <a href="/countries" class="navbar-mobile-item"><i class="glyphicon glyphicon-globe"></i></a>
                <a href="/indicators" class="navbar-mobile-item"><i class="glyphicon glyphicon-stats"></i></a>
                <a noref class="navbar-mobile-item" id="thisIsTheTinyGlyphiconId"> <i class="glyphicon glyphicon-search"></i> </a>
            </div>
        </div>

        <div class="navbar-collapse collapse">
            <ul class="nav navbar-nav">

                <li class="dropdown ">
                    <a href="/calendar">CALENDAR</a>
                </li>

               <li class="dropdown ">
                     <a href="#" class="dropdown-toggle" data-toggle="dropdown">INDICATORS<b class="caret hidden-sm"></b></a>
                    <ul class="dropdown-menu">
                        <li class='nav-item'><a href="/countries" target="_self">Countries</a></li>
                        <li class='nav-item'><a href="/indicators" target="_self">Indicators</a></li>
                    </ul>
                </li>
    

                <li class="dropdown  ">
                    <a href="#" class="dropdown-toggle" data-toggle="dropdown">MARKETS<b class="caret hidden-sm"></b></a>
                    <ul class="dropdown-menu">
                        <li class='nav-item'><a href="/currencies" target="_self">Currencies</a></li>
                        <li class='nav-item'><a href="/stocks" target="_self">Stocks</a></li>
                        <li class='nav-item'><a href="/commodities" target="_self">Commodities</a></li>
                        <li class='nav-item'><a href="/bonds" target="_self">Bonds</a></li>
                        <li class='nav-item'><a href="/earnings" target="_self">Earnings</a></li>
                    </ul>
                </li>

                <li class="dropdown ">
                  <a href="#" class="dropdown-toggle" data-toggle="dropdown">FORECASTS<b class="caret hidden-sm"></b></a>
                <ul class="dropdown-menu">
                        <li class='nav-item'><a href="/forecasts" target="_self">Countries</a></li>
                        <li class='nav-item'><a href="/indicators?g=forecast" target="_self">Indicators</a></li>
                        <li class='nav-item'><a href="/forecast/currency" target="_self">Currencies</a></li>
                        <li class='nav-item'><a href="/forecast/stock-market" target="_self">Stocks</a></li>
                        <li class='nav-item'><a href="/forecast/commodity" target="_self">Commodities</a></li>
                        <li class='nav-item'><a href="/forecast/government-bond-10y" target="_self">Bonds</a></li>
                    </ul>
                </li>
                    
                       <li>
                        <a noref id="thisIsTheSearchPlaceholderId" class="nav-searchbox-class stickydropdown-toggle hidden-xs" title="Search" style="margin-left: 20px; margin-top: -3px;">
                            <div id="thisIsTheSearchBoxWrapperId" class="typeahead-searchbox-glyphicon-wrapper" >

                                <input type="text" placeholder="Search"
                                        id="thisIstheSearchBoxIdTag"
                                        autocomplete="off"
                                        class="hidden-xs hidden-sm nav-search-input-class"
                                       style="border: 0px; color: #333; /*border-bottom: 1px solid #858585;*/ background-color: transparent;"/>

                                <i id="thisIsTheBigGlyphiconId" class="glyphicon glyphicon-search hidden-sm nav-search-glyphicon-class" style="color: #858585; padding-bottom: 2px;padding-right: 2px;margin-left: -5px;">
                                </i>
                                <i id="thisIsTheSmallGlyphiconId" class="glyphicon glyphicon-search hidden-md hidden-lg nav-search-glyphicon-class" style="
                                    color: #858585;">
                                </i>

                            </div>
                        </a>

                        <ul id="thisIstheSearchResultsIdTag" class="dropdown-menu" style="position: fixed; width: 100%; top: 54px; border-top-color: #FFF;display: block;padding: 0;border: 0;">
                            <li>
                                <div class="container">
                                    <div id="dpSearch-resultCnt" class="dpTaResult">
                                    </div>
                                </div>
                            </li>
                        </ul>
                    </li>
                 
                
            </ul>

            <ul class="nav pull-right"  style="padding-top: 10px;" >
                 <li id="ctl00_NavigationUC1_menuGuest" class="dropdown pull-right">
                    <a href="#" class="dropdown-toggle" data-toggle="dropdown">
                        <i class="glyphicon glyphicon-th-large" style="color: #ff6a00"></i>
                        <span class="hidden-sm hidden-md" style="color: #ff6a00">&nbsp;<b>APPS</b><b class="caret hidden-sm"></b></span></a>
                    <div class="dropdown-menu list-group pull-right" style="min-width: 300px;">
                        
                        <a href="/analytics/features.aspx" class="list-group-item" target="_self">
                            <b class="list-group-item-heading"><i class="glyphicon glyphicon-floppy-disk"></i>&nbsp;DATA</b><br>
                            <span class="list-group-item-text">Download historical data for 20 million indicators using your browser.</span>
                        </a>

                        <a href="https://sso.tradingeconomics.com/?returnurl=https://tradingeconomics.com/privacy-policy.aspx" class="list-group-item" style="padding-top: 3px; padding-bottom: 3px;" target="_blank">Already a user? Login
                        </a>

                        <a href="/api/" class="list-group-item" target="_self">
                            <b class="list-group-item-heading"><i class="glyphicon glyphicon-phone"></i>&nbsp;API GATEWAY</b><br>
                            <span class="list-group-item-text">Direct access to our calendar releases and historical data from your apps.</span>
                        </a>

                        <a href="https://alerts.tradingeconomics.com" class="list-group-item" target="_blank">
                            <b class="list-group-item-heading"><i class="glyphicon glyphicon-bell"></i>&nbsp;ALERTS</b><br>
                            Receive releases for indicators in your mail inbox and set alerts for markets.
                        </a>

                          <a href="https://estimates.tradingeconomics.com" class="list-group-item" target="_blank">
                            <b class="list-group-item-heading"><i class="glyphicon glyphicon-stats"></i>&nbsp;ESTIMATES</b><br>
                           Join the world's largest survey of market forecasts and estimates for indicators. 
                        </a>
                    </div>
                </li>
                
                </ul>
        </div>
          
    </div>
</div>



            <div class="row">
                <div class="col-lg-8 col-md-9" role="main">
                    <div style="width: 100%; text-align: center;">
                        
                    </div>
                    
<br />


 <table border="0" cellpadding="0" cellspacing="0" style="width: 720px; text-align: justify">
        <tr>
            <td width="20px">
            </td>
            <td style="text-align: justify">

<b>PRIVACY POLICY</b>
<br />
<br />
                
                <b>Security Technology </b>
                <br />
                <br />
                Trading Economics uses Secure Socket Layer (SSL) encryption technology in order to protect 
                certain information that you submit. This type of technology protects you from 
                having your information intercepted by anyone other than Trading Economics while it is being 
                transmitted to us. We work hard to ensure that our Web sites are secure and that 
                they meet industry standards. We also use other safeguards such as firewalls, 
                authentication systems (e.g., passwords and personal identification numbers), 
                and access control mechanisms to control unauthorized access to systems and 
                data.
                <br />
                <br />
                <br />
                <b>About Cookies</b><br />
                <br />
                Cookies are small files containing information that a Web site uses to track its 
                visitors. Trading Economics may set and access Trading Economics cookies on your computer, enabling us to 
                learn which advertisements and promotions bring users to our Web site. Trading Economics or 
                any of its divisions may use cookies in connection with Trading Economics products and 
                services to track your activities on our Web sites. Such information that we 
                collect and share would be anonymous and not personally identifiable.
                <br />
                <br />
                <br />
                <b>Sharing Information with Our Affiliates </b>
                <br />
                <br />
                We may share personal information described above with our affiliates for 
                business purposes, such as servicing customer accounts and informing customers 
                about new products and services, and as permitted by applicable law. Our 
                affiliates may include companies controlled or owned by us as well as companies 
                that have an ownership interest in our company. The information we share with 
                affiliates may include any of the information described above, such as your 
                name, address, and account information. Our affiliates maintain the privacy of 
                your information to the same extent Trading Economics does in accordance with this Policy.
                <br />
                <br />
                <br />
                <b>Sharing Information with Third Parties</b><br />
                <br />
                Trading Economics does not disclose your personal information to third parties, except as 
                described in this Policy. Third party disclosures may include sharing such 
                information with non-affiliated companies that perform support services for your 
                account or facilitate your transactions with Trading Economics, including those that provide 
                professional, legal, or accounting advice to Trading Economics. Non-affiliated companies that 
                assist Trading Economics in providing services to you are required to maintain the 
                confidentiality of such information to the extent they receive it and to use 
                your personal information only in the course of providing such services and only 
                for the purposes that Trading Economics dictates. We may also disclose your personal 
                information to third parties to fulfill your instructions or pursuant to your 
                expressed consent. We want you to know that Trading Economics will not sell your personal 
                information.
                <br />
                <br />
                <br />
                <b>Regulatory Disclosure</b><br />
                <br />
                Under limited circumstances, Trading Economics may disclose your personal information to 
                third parties as permitted by, or to comply with, applicable laws and 
                regulations. For example, we may disclose personal information to cooperate with 
                regulatory authorities and law enforcement agencies to comply with subpoenas or 
                other official requests, and as necessary to protect our rights or property. 
                Except as described in this privacy policy, we will not use your personal 
                information for any other purpose, unless we describe how such information will 
                be used at the time you disclose it to us or we obtain your permission.
                <br />
                <br />
                <br />
                <b>Opt Out<br />
                </b>
                <br />
                You are not required to supply any of the personal information that we may 
                request; however, failure to do so may result in our being unable to open or 
                maintain your account or to provide services to you. While we make every effort 
                to ensure that all information we hold about you is accurate, complete, and up 
                to date, you can help us considerably in this regard by promptly notifying us if 
                there are any changes to your personal information.</td>
        </tr>
    </table>
    <br />
    <br />
    <br />



                </div>
                
            </div>
            <br />
            <br />
        </div>
        <div class="container-fluid" style="background-color: #000; color: #ffffff;">
            <footer style="padding: 20px;">
                <div class="container">
                    <div class="row">
                        <div id="ctl00_Footer1_PanelFooter">
	
    <br />
    <div class="container">
        <div class="row">
            <div class="col-md-2 col-sm-2 col-xs-6">
                <span style="font-weight: bold; text-transform: uppercase;">Indicators</span><br />
                <a id="ctl00_Footer1_HyperLink6" class="footerItems" href="./">Homepage</a><br />
                <a id="ctl00_Footer1_HyperLink17" class="footerItems" href="countries">Countries</a><br />
                <a id="ctl00_Footer1_HyperLink18" class="footerItems" href="indicators">Indicators</a><br />
                <a id="ctl00_Footer1_HyperLink1" class="footerItems" href="calendar">Calendar</a><br />
                <a id="ctl00_Footer1_HyperLink2" class="footerItems" href="forecasts">Forecasts</a><br />
                <a id="ctl00_Footer1_HyperLink11" class="footerItems" href="country-list/rating">Ratings</a>
                
            </div>

            <div class="col-md-2 col-sm-2 col-xs-6">
                <span style="font-weight: bold; text-transform: uppercase;">About Us</span><br />
                <a id="ctl00_Footer1_HyperLink19" class="footerItems" href="about-te.aspx">History</a><br />
                <a id="ctl00_Footer1_HyperLink20" class="footerItems" href="advertise.aspx">Advertisers</a><br />
                <a id="ctl00_Footer1_HyperLink21" class="footerItems" href="investors.aspx">Investors</a><br />
                <a id="ctl00_Footer1_HyperLink23" class="footerItems" href="careers.aspx">Careers</a><br />
                <a id="ctl00_Footer1_HyperLink8" class="footerItems" href="contact.aspx">Contact</a><br />
                <a id="ctl00_Footer1_HyperLink9" class="footerItems" href="privacy-policy.aspx">Privacy</a>

            </div>
            <div class="col-md-2 col-sm-2 col-xs-6">
                <span style="font-weight: bold; text-transform: uppercase;">Follow Us</span><br />
                <a href="https://www.facebook.com/TradingEconomics"><span class="footerItems">Facebook</span></a><br />
                <a href="https://www.twitter.com/teconomics"><span class="footerItems">Twitter</span></a><br />
                <a href="https://tradingeconomics.com/rss/"><span class="footerItems">RSS</span></a>
                <br />
                <br />
            </div>
            <div class="col-md-1 col-sm-1">
                <br /><div class="visible-xs visible-sm">&nbsp;<br /></div>
                <a href="https://itunes.apple.com/us/app/trading-economics/id1142178921?mt=8" style="display: inline-block; overflow: hidden; background: url(//d3fy651gv2fhd3.cloudfront.net/images/appstore-lrg.svg?v=20171228) no-repeat; width: 135px; height: 40px; background-size: contain;"></a>
                <br /><br />
                <a href="https://play.google.com/store/apps/details?id=com.tradingeconomics.android"><img alt="Android app on Google Play"src="/images/google-play.png" /></a>
            </div>

        </div>
    </div>
    <br />
    <div class="container">
        <div class="row">
            <div class="col-md-4 col-sm-4 col-xs-12">
                <span style="font-weight: bold; text-transform: uppercase; color: green">Solutions</span>
            </div>
            <div class="col-md-4 col-sm-4 col-xs-12">
                <span style="font-weight: bold; text-transform: uppercase; color: slategray">Our Sites</span>
            </div>
        </div>
        <div class="row">
            <div class="col-md-2 col-sm-2 col-xs-6">
                <a href="/api/?source=footer" target="_self" class="footerItems">
                    <b class="list-group-item-heading"><i class="glyphicon glyphicon-floppy-disk"></i>&nbsp;API ACCESS</b><br>
                    <span class="list-group-item-text">Direct access to our calendar releases and historical data.</span>
                </a>
            </div>
            <div class="col-md-2 col-sm-2 col-xs-6">
                <a href="/analytics/features.aspx?source=footer" target="_self" class="footerItems">
                    <b class="list-group-item-heading"><i class="glyphicon glyphicon-floppy-disk"></i>&nbsp;EXPORT DATA</b><br>
                    <span class="list-group-item-text">Download historical data for 20 million indicators using your browser.</span>
                </a>
            </div>
            <div class="col-md-2 col-sm-2 col-xs-6">
                <a href="https://ieconomics.com" target="_blank" class="footerItems">
                    <b class="list-group-item-heading"><i class="glyphicon glyphicon-random"></i>&nbsp;IECONOMICS</b><br>
                    <span class="list-group-item-text">Intelligent search to get instant answers with data and charts.</span>
                </a>
            </div>
            <div class="col-md-2 col-sm-2 col-xs-6">
                <a href="https://ueconomics.com" target="_blank" class="footerItems">
                    <b class="list-group-item-heading"><i class="glyphicon glyphicon-th-large"></i>&nbsp;UECONOMICS</b><br>
                    <span class="list-group-item-text">Dashboard to drag & drop charts and store your calendar preferences.
                    </span>
                </a>

            </div>
        </div>
    </div>
    <br />
    <span style="font-weight: bold; text-transform: uppercase; padding-left: 15px; color: darkorange">Languages</span><br />
    
<div class="container">
    <div class="row">
        <div class="col-md-1 col-sm-2 col-xs-6">
            <a class="footerItems" href="https://tradingeconomics.com" target="_self">English</a><br />
            <a class="footerItems" href="https://es.tradingeconomics.com" target="_self">Español</a><br />
            <a class="footerItems" href="https://pt.tradingeconomics.com" target="_self">Português</a><br />
            <a class="footerItems" href="https://fr.tradingeconomics.com" target="_self">Français</a><br />
            <a class="footerItems" href="https://de.tradingeconomics.com" target="_self">Deutsch</a><br />
            <a class="footerItems" href="https://it.tradingeconomics.com" target="_self">Italiano</a><br />
        </div>
        <div class="col-md-1 col-sm-2 col-xs-6">
            <a class="footerItems" href="https://ru.tradingeconomics.com" target="_self">Русский</a><br />
            <a class="footerItems" href="https://pl.tradingeconomics.com" target="_self">Polski</a><br />
            <a class="footerItems" href="https://da.tradingeconomics.com" target="_self">Dansk</a><br />
            <a class="footerItems" href="https://sv.tradingeconomics.com" target="_self">Svenska</a><br />
            <a class="footerItems" href="https://no.tradingeconomics.com" target="_self">Norsk</a><br />
            <a class="footerItems" href="https://fi.tradingeconomics.com" target="_self">Suomi</a><br />
        </div>
        <div class="col-md-1 col-sm-2 col-xs-6">
            <a class="footerItems" href="https://tr.tradingeconomics.com" target="_self">Türkçe</a><br />
            <a class="footerItems" href="https://hu.tradingeconomics.com" target="_self">Magyar</a><br />
            <a class="footerItems" href="https://fa.tradingeconomics.com" target="_self">Farsi</a><br />
            <a class="footerItems" href="https://id.tradingeconomics.com" target="_self">Indonesian</a><br />
            <a class="footerItems" href="https://ms.tradingeconomics.com" target="_self">Malay</a><br />
            <a class="footerItems" href="https://sw.tradingeconomics.com" target="_self">Swahili</a><br />
        </div>
        <div class="col-md-1 col-sm-2 col-xs-6">
            <a class="footerItems" href="https://zh.tradingeconomics.com" target="_self">简体中文</a><br />
            <a class="footerItems" href="https://jp.tradingeconomics.com" target="_self">日本語</a><br />
            <a class="footerItems" href="https://ko.tradingeconomics.com" target="_self">한국어</a><br />
            <a class="footerItems" href="https://hi.tradingeconomics.com" target="_self">हिंदी</a><br />
            <a class="footerItems" href="https://bn.tradingeconomics.com" target="_self">বাংলা</a><br />
            <a class="footerItems" href="https://ar.tradingeconomics.com" target="_self">العربية</a><br />
            <a class="footerItems" href="https://ur.tradingeconomics.com" target="_self">اردو</a><br />
        </div>
    </div>
</div>
    <br />
    <span style="color: #E7E7EF">Copyright ©2018 TRADING ECONOMICS<br />
        All Rights Reserved</span><br />
    <br />
    <br />
    

</div>


                    </div>
                </div>
            </footer>
        </div>
    </form>
    <script src="https://code.jquery.com/jquery-3.2.1.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.2/js/bootstrap.min.js"></script>
    
<script type="text/javascript">
    var chartUrl = '/privacy-policy.aspx';
    var chartUrl2 = "";
    var startDate = "";
    var endDate = "";
    var chartType = "";
    if (!isPostBack) {
        console.log("HISTORICAL CHART JS");
        chartUrl = $('#ImageChart').attr('src');
        /*
        if (chartUrl != null && chartUrl.indexOf("1x1") > -1 ) {
           // chartUrl = 'https://d3fy651gv2fhd3.cloudfront.net/charts/euro-area-currency.png?s=eurusd&v=201611281645r';
            //SetSrc(chartUrl);
            //SetChart();
        }*/
    }
    else {
        console.log("HISTORICAL CHART POSTBACK");
    }

    function SetSrc(src) {
        console.log("chart src:" + src);
        $('#ImageChart').attr("src", src);
        var srcset = src + " 1x";
        srcset += ", " + src.replace(".png", "@2x.png") + " 2x";
        srcset += ", " + src.replace(".png", "@3x.png") + " 3x";
        srcset += ", " + src.replace(".png", "@4x.png") + " 4x";
        //var srcset = src + "&w=200 500w";
        //srcset += ", " + src + "&w=100 730w";
        $('#ImageChart').attr("srcset", srcset);
    }
    $('.chart-lookback').click(function () {
        console.log("chart lookback click");
        var now = new Date();
        endDate = now.getFullYear() + '1231';
        console.log("endDate: " + endDate);
        var lookback = $(this).attr("data-lookback")
        console.log("lookback: " + lookback);
        startDate = now.getFullYear() - lookback + "0101"
        console.log("startDate: " + startDate);
        SetChart()
    });

    $('#chart-custom-dates').click(function () {
        startDate = $('#startDate').val().replace("-", "").replace("-", "");
        console.log("endDate: " + startDate);
        endDate = $('#endDate').val().replace("-", "").replace("-", "");
        console.log("endDate: " + endDate);
        SetChart();
    });

    $('.chart-type').click(function () {
        chartType = $(this).attr("data-type")
        console.log("chartType: " + chartType);
        SetChart();
    });

    function SetChart() {
        console.log("Updating Chart..");
        $('#spinner').css("visibility", "visible");
        var src = chartUrl;
        if (startDate != "") src += "&d1=" + startDate;
        if (endDate != "") src += "&d2=" + endDate;
        if (chartType != "") src += "&" + chartType;
        if (chartUrl2 != "") src += "&url2=" + chartUrl2;
        SetSrc(src);
        SetEmbed();
    }



    function SetComparison(url2) {
        console.log("Comparing with");
        console.log(url2);
        chartUrl2 = url2;
        SetChart();
    }
    function SetEmbed() {
        console.log("Setting Embed...");
        console.log("embed chart url:" + chartUrl);
        var src = "https://d3fy651gv2fhd3.cloudfront.net/embed/?";
        src += chartUrl.substring(chartUrl.indexOf("?") + 1);
        if (startDate != "") src += "&d1=" + startDate;
        if (endDate != "") src += "&d2=" + endDate;
        if (chartType != "") src += "&type=" + chartType;
        if (chartUrl2 != "") src += "&title=false&url2=" + chartUrl2;
        var embedHeight = $('#TextBoxHeight').val();
        var embedWidth = $('#TextBoxWidth').val();
        src += "&h=" + embedHeight;
        src += "&w=" + embedWidth;
        console.log("embed url:" + src);
        var embedText = "<iframe src='" + src + "' height='" + embedHeight + "' width='" + embedWidth + "'  frameborder='0' scrolling='no'></iframe><br />source: <a href='" + location.href + "'>tradingeconomics.com</a>"
        $('#TextBoxEmbed').val(embedText);
        $('#embedPreviewLink').attr("href", src);
    }
    $('#DropDownListCategory').change(function () {
        console.log("Changing Categories...");
    });
    $('#embedButton').click(function () {
        console.log("Expanding Embed...");
    });

    $('#TextBoxWidth').keyup(function () {
        console.log("Setting Embed Width...");
        SetEmbed();
    });
    $('#TextBoxHeight').keyup(function () {
        console.log("Setting Embed Height...");
        SetEmbed();
    });

    $('#ImageChart').on('load', function () {
        console.log("Completed load of chart...");
        $('#spinner').css("visibility", "hidden");
    });


    // LOAD HISTORICAL CHART ASYNC
    $('a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
        var target = $(e.target).attr("href");
        console.log("User Clicked Chart Tab " + target);

        if (target == "#historical" || target == "#forecast") {
            var src = 'https://d3fy651gv2fhd3.cloudfront.net/charts/historical.png';
            src += '?s=' + encodeURI(TESymbol);
            src += '&v=' + TELastUpdate;

            if (target == "#historical") {
                chartUrl = src;
                SetChart();
            }
            if (target == "#forecast") {
                src += '&forecast=3';
                $('#ForecastChart').attr("src", src);
                var srcset = src + " 1x";
                srcset += ", " + src.replace(".png", "@2x.png") + " 2x";
                srcset += ", " + src.replace(".png", "@3x.png") + " 3x";
                srcset += ", " + src.replace(".png", "@4x.png") + " 4x";
                $('#ForecastChart').attr("srcset", srcset);
            }
        }

        if (target == "#alerts") {
            $('#AlertMePanel').collapse('show');
        }
    });

    $(document).ready(function () {
        if (document.location.href.indexOf("#alerts") > -1) {
            console.log("Expand AlertMePanel");
            //$('#AlertMePanel').prepend("<br/>ALERTS<br/><br/>")
            $('.nav-tabs a[href="#alerts"]').tab('show');
            //$('#AlertMePanel').collapse('show');
        }
    });



</script>

<script>
	var ta_opts = {}
	ta_opts.minLength = 1;
	ta_opts.showHintOnFocus = true;
	ta_opts.items = 6;
	ta_opts.goForContext = true;
	ta_opts.inContextLength = 4;
	ta_opts.allowNavigator = true;
	//ta_opts.universe = 'economy'
	ta_opts.universe = 'te-charts';
	ta_opts.universe = 'economic,forex,commodity,idx,bond';
	ta_opts.field = 'url';
	ta_opts.origins = 'te';

	var TypeAheadSymbol = '';
	if (symbol != '' && symbol.indexOf(':') > -1) TypeAheadSymbol = symbol;
	else if (TESymbol != '') {
	    if (TESymbol.indexOf(':') > -1) TypeAheadSymbol = TESymbol;
	    else TypeAheadSymbol = TESymbol + ':te';
	}
	
	console.log("TypeAheadSymbol", TypeAheadSymbol)

	ta_opts.inContextContext = TypeAheadSymbol;
	ta_opts.exclude = TypeAheadSymbol;

	ta_opts.onSelection = function( data ){
		console.log('data', data)
		SetComparison( data );
	}

	ta_opts.initializeAt = '#compare .typeahead'
	window.initializeTypeaheadWhenReady = ta_opts
	//$('#compare .typeahead.iec').ieconomicsTypeahead( ta_opts )
</script>



    
    
    <script async src="https://d3fy651gv2fhd3.cloudfront.net/scripts/iec-config-typeahead.js?v=20180525"></script>

<script>
    if ($("#estimates-ad").length == 0) {
        console.log("ESTIMATES BANNER WAS NOT FOUND.");
    }
    else {
        if (TESymbol != '') {
            if (window.location.pathname.split('/').length == 3) {
                estimatesUrl = window.location.href + "/forecast";
                $("#estimates-ad").attr("href", estimatesUrl);
            }
        }
    }
</script>

<div id="ctl00_js_ctl03_PanelProduction">
	<script>console.log("Alerts => Production")</script><script async src="https://alerts.tradingeconomics.com/scripts/te-alerts.js" type="text/javascript" ></script>
</div>



<script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/1.7.3/socket.io.min.js"></script>
<script src="https://d3fy651gv2fhd3.cloudfront.net/scripts/pnotify.custom.min.js?v=201700830"></script>
<link href="https://d3fy651gv2fhd3.cloudfront.net/content/pnotify.custom.min.css?v=20170830" rel="stylesheet" />

<script type="text/javascript">
    console.log('IO.JS v20170709');
    var MKT_TBL_SELEC = "#table-logic-handler-for-sockets";
    var TE_URL = window.location.pathname;
    var TEChannels = ['calendar'];
    
    var MKTChannels = [];
    
    var KILL_SOCKET_AFTER_IDLE = 1000 * 60 * 30; // 30 MINUTES
    var IS_CONNECTED = false;

    console.log('TE_URL', TE_URL)
if (TE_URL == '/') TEChannels = ['calendar', 'market'];
else if ( TE_URL.indexOf("calendar") > -1 ) TEChannels = ['calendar', 'market'];
else if (TE_URL.indexOf("calendar") > -1 || TE_URL.indexOf("/dividends") > -1 || TE_URL.indexOf("/ipo") > -1 || TE_URL.indexOf("/stock-splits") > -1 || TE_URL.indexOf("/earnings") > -1) TEChannels = ['calendar', 'market'];
else if ( TE_URL.indexOf("stream") > -1 ) TEChannels = ['calendar','market', 'stream'];
else if ( TE_URL.indexOf("/currencies") > -1 ) TEChannels = ['currencies', 'calendar'];
else if ( TE_URL.indexOf("/stocks") > -1 ) TEChannels = ['indexes', 'calendar'];
else if ( TE_URL.indexOf("/bonds") > -1 ) TEChannels = ['bonds', 'calendar'];
else if ( TE_URL.indexOf("/commodities") > -1 ) TEChannels = ['commodities', 'calendar'];
else if ( TE_URL.indexOf("/currency") > -1 || TE_URL.indexOf("/stock-market") > -1 || TE_URL.indexOf("/commodity/") > -1 || TE_URL.indexOf("/government-bond-yield") > -1)
    TEChannels = ['market', 'calendar'];
else if (TE_URL.split(':').length == 3 || TE_URL.indexOf("/forecast") > -1)
    TEChannels = ['calendar', 'market'];

var socket_url = 'https://io.tradingeconomics.com?app=te&token=20171116';



console.log('IO CONNECTING ' + socket_url);
var socket = io.connect(socket_url);

function GO_IO() {
    IS_CONNECTED = true;
    var _lag0 = 'seconds:2';
    console.log('IO CONNECTED');
    console.log('IO SUBSCRIBE TO ' + TEChannels, _lag0);
    socket.emit('subscribe', { s: TEChannels, lag: _lag0 })


    gatherMKTChannels();
    if (MKTChannels && MKTChannels.length) {
        var _lag = 'seconds:5';



        console.log('IO SUBSCRIBE TO ' + MKTChannels, _lag);
        socket.emit('subscribe', { s: MKTChannels, lag: _lag })
    }
    socket.on('disconnect', function () {
        IS_CONNECTED = false;
        console.log('Got disconnect!');
    });


    socket.on("smooth-disconnect", function () {
        socket.disconnect();
    });

}

socket.on('connect', GO_IO);

var isSnap = true;

for (var i = 0; i < TEChannels.length; i++) {
    channel = TEChannels[i];
    if (channel == 'calendar' || channel == 'stream') continue;
    console.log('IO Snap ' + channel);
    socket.on(channel, function (a) {
        if (a.length > 0) {
            for (i = 0; i < a.length; i++) {
                TE_UpdateTable(a[i], isSnap)
            }
            isSnap = false;
        }
        else {
            console.log('IO Sent Empty Market Update');
        }
    });
}


socket.on('tick', function (t) {
    //console.log('tick', t);
    TE_UpdateTable(t);
});

function gatherMKTChannels() {
    //console.log('now what?', $("[data-subscribe]"), $("[data-subscribe]").length)
    $("[data-subscribe]").each(function (i, item) {
        //console.log(i, item, $(item).attr('data-subscribe'));
        if ($(item).attr('data-subscribe')) {
            MKTChannels.push($(item).attr('data-subscribe'))
        }
    })
}

function TE_UpdateTable(d, isSnap) {
    //console.log(d);
    //if (d.state != 'open') {console.log("Market Closed:", d);};
    var s = d.s;

    //console.log('s', s);
    /*if (s == 'CO1:COM') {
        console.log(d)
    }*/
    var r = $('tr[data-symbol="' + s + '"]');
    var p = r.find('td#p');

    var dec = 4;
    if (typeof r.data('decimals') !== 'undefined') dec = r.data("decimals");

    var p0 = parseFloat(p.text());

    if (p0 != d.p.toFixed(dec)) {

        p.text(d.p.toFixed(dec));

        fg = d.nch > 0 ? 'darkgreen' : d.nch < 0 ? 'darkred' : 'black';
        
        triangle = d.p > d.prev ? '<span class="market-positive-image"></span>' : d.nch < 0 ? '<span class="market-negative-image"></span>' : '<span class="market-neutral-image"></span>';

        /*if (s == 'CO1:COM') {
            console.log(d.nch, 'triangle', triangle);
        }*/

        var previous_triangle = r.find('td#triangle');

        if (previous_triangle && previous_triangle.length) {
            previous_triangle.html(triangle);
            //triangle = '';            
            //previous_triangle.attr("id", "newId");
        }

        
        var nch = r.find('td#nch');

        //if (s == 'INDU:IND') {
            //console.log('nch', nch.length, nch);
            if (nch) {
                nch.each(function (i, item) {
                    //console.log(i, item);
                    //return;
                    if ($(item).attr("data-no-triangle")) {

                        $(item).text(d.nch.toFixed(dec));
                        $(item).css("color", fg);
                        $(item).html(Math.abs(d.nch.toFixed(dec)));
                    } else {

                        $(item).text(d.nch.toFixed(dec));
                        $(item).css("color", fg);
                        $(item).html(triangle + ' ' + Math.abs(d.nch.toFixed(dec)));

                    }
                })
            }
       //}


        /*
        nch.text(d.nch.toFixed(dec));
        nch.css("color", fg);
        nch.html(triangle + ' ' + Math.abs(d.nch.toFixed(dec)));
        */
        

        var pch = r.find('td#pch');
        pch.text(d.pch.toFixed(2) + ' %');
        pch.css("color", fg);

        if (TEChannels != "market") {
            nch.attr('data-value', d.nch);
            pch.attr('data-value', d.pch);
        }

        r.find('td#pch')

        bg = '#cdebf9'; //#cdebf9
        p.css("backgroundColor", bg);

        setTimeout(function () {
            p.css("backgroundColor", '#ffffff');
        }, 2000)

        if (!isSnap) {
            var dt = new Date();
            var h = dt.getHours(); if (h < 10) { h = "0" + h; }
            var m = dt.getMinutes(); if (m < 10) { m = "0" + m; }
            var ds = [h, m].join(':');
            r.find('td#date').html(ds);
        }

        if (d.type == 'index') {
            var stateColor = '', stateSpan = '';
            var state = d.state;
            if (d.dstate) state = d.dstate;

            if (state == 'open') stateColor = 'green';
            else if (state == 'closed') stateColor = 'red';
            else if (state == 'pre') stateColor = '#CFB53B';
            else if (state == 'after') stateColor = '#CFB53B';

            if (stateColor != '') {
                stateSpan = '<span class="glyphicon glyphicon-dashboard" style="font-size:11px; color: ' + stateColor + '" title="' + state + ' trading session"></span>';
                r.find('td#session').html(stateSpan);
            }
        }


    }
    else {
        p.css("backgroundColor", 'rgb(255,255,255)');
    }

};

var TENotifications = 0;

// CALENDAR + STREAM
function TENotification(_title, _text, _url, _importance) {


    TENotifications++;

    console.log("IO => Notification => ", _title, _text, _url, _importance, TENotifications);

    if (TENotifications > 2 & _importance <= 1) return;
    if (TENotifications > 4 & _importance <= 2) return;

    var IsDesktop = false;
    var _titleHTML = 'ALERT';
    var _alertType = 'NEWS';
    var _color = "#5bc0de";

    if (_importance > 0) {
        _alertType = 'CALENDAR';
        if (_importance > 1) {
            IsDesktop = true;
            _color = '#5cb85c';
            if (_importance > 2) _color = '#d9534f';
        }
    }

    _titleHTML = '<div style="padding-bottom:10px; font-size: 11px;color: #fff; font-weight: bold;"><span style="background-color: #000; padding: 3px;">' + _alertType + '</span><span style="background-color: ' + _color + '; padding: 3px;">ALERT</span></div>';

    var _textHTML = _text;
    if (_text && _text.length > 200) {
        console.log("Trim text");
        _textHTML = _text.substring(0, 200) + '...';
        _textHTML += ' <a style="text-decoration: underline;" target="_new" href="' + _url + '">More</a>';
    }
    else if (_text) {
        _textHTML += ' <a style="text-decoration: underline;" target="_new" href="' + _url + '">More</a>';
    }

    ///if (IsDesktop) PNotify.desktop.permission();
    PNotify.desktop.permission();

  
    (new PNotify({
        title: _titleHTML,
        text: _textHTML,
        hide: false,
        animation: 'fade',
        shadow: true,
        icon: false,
        mouse_reset: false,
        hide: true,
        delay: 30000,
        buttons: {
            sticker: false
        },
        addclass: 'custom',
    })).get().click(function (e) {
        if ($('.ui-pnotify-closer, .ui-pnotify-sticker, .ui-pnotify-closer *, .ui-pnotify-sticker *').is(e.target)) {
            console.log("Closed Notification");
            return;
        }
        window.location = _url;
    });

    if (IsDesktop) {

        var _tag = _url + "?v=" + new Date().toISOString().slice(0, 10).replace(/-/g, "");
        console.log("PNotify tag", _tag);

        (new PNotify({
            title: _titleHTML,
            text: _textHTML,
            hide: false,
            animation: 'fade',
            shadow: true,
            icon: false,
            mouse_reset: false,
            hide: true,
            delay: 30000,
            buttons: {
                sticker: false
            },
            addclass: 'custom',
            type: 'info',
            desktop: {
                desktop: IsDesktop,
                title: 'TRADING ECONOMICS',
                text: _text,
                tag: _tag,
                fallback: false
                //icon: '/images/logo2.png'
            }
        })).get().click(function (e) {
            if ($('.ui-pnotify-closer, .ui-pnotify-sticker, .ui-pnotify-closer *, .ui-pnotify-sticker *').is(e.target)) {
                console.log("Closed Notification");
                return;
            }
            window.location = _url;
        });;
    }

}

function TECalendarRowUpdate(c) {
    console.log("UPDATE CALENDAR ROW");

    var $row = $('tr[data-id="' + c.CalendarId + '"]');
    var $td = $row.find('span#actual');
    $td.text(c.Actual);
    bg = '#5bc0de';
    $td.css("backgroundColor", bg);
    color = c.Actual.indexOf("-") ? 'darkgreen' : 'darkred';
    $td.css("color", color);

    $row.find('span#previous').text(c.Previous);

    $row.find('img#incoming').css("display", 'none');

    //$td.slideUp();
    setInterval(function () {
        $td.css("backgroundColor", '#ffffff');
        //console.info("Flash");
    }, 2000);
}

socket.on('calendar', function (c) {
    console.log("IO CALENDAR")
    console.log(c);
    //var c = JSON.parse(_c);
    if (c.Importance >= 1) {
        var _title =  c.Country.trim() + ' ' + c.Event.trim();
        var _text = _title;
        if (c.Actual != null && c.Actual != '') _text += '  reported at ' + c.Actual + '. ';
        if (c.Forecast != null && c.Forecast != '') _text += 'Consensus was ' + c.Forecast + '. ';
        if (c.Previous != null && c.Previous != '') _text += 'Previously at ' + c.Previous + '.';
        var _url = 'https://tradingeconomics.com' + c.URL;

        if (TE_URL.indexOf("calendar") > -1) TECalendarRowUpdate(c);

        TENotification(_title, _text, _url, c.Importance);

    }
});

socket.on('stream', function (j) {
    console.log("IO STREAM")
    console.log(j);
    var _title = j.title;
    var _description = j.description;
    var _url = j.url;
    if (_title && _description && _url) {
        TENotification(_title, _description, _url, 0);
    }
});


    



    

    var LAST_VISIBLE = new Date().getTime();

    function saveSocketNetworkBW() {

        if (TE_URL.indexOf("calendar") > -1) return;
        if (TE_URL.indexOf("stream") > -1) return;
        if (TE_URL.indexOf("/currencies") > -1) return;
        if (TE_URL.indexOf("/stocks") > -1) return;
        if (TE_URL.indexOf("/bonds") > -1) return;
        if (TE_URL.indexOf("/commodities") > -1) return;

        setInterval(function () {
            if (typeof document == 'undefined' || !document) return LAST_VISIBLE = new Date().getTime();
            if (typeof document.hidden != 'boolean') return LAST_VISIBLE = new Date().getTime();

            //console.log('document.hidden', document.hidden, typeof document.hidden);
            if (!document.hidden) {

                if (!IS_CONNECTED) {
                    console.log('GOING IN!');
                    socket.connect();
                }

                return LAST_VISIBLE = new Date().getTime();
            }

            var now = new Date().getTime();
            if (now - LAST_VISIBLE > KILL_SOCKET_AFTER_IDLE) {
                if (IS_CONNECTED) {
                    console.log('GOING OUT!');
                    socket.disconnect();
                }
            }

        }, 1000 * 1);
    }

    saveSocketNetworkBW();

</script>






<script>
    var loader = "<div style='display:flex;flex-direction:column;align-items:center;padding:20px;'><div class='loader' style='width:30px;height:30px;'></div></div>";

    function hide_msg(element, miliseconds) {
        // hide the message after some time
        setTimeout(function () {
            element.fadeOut(1000);
        }, miliseconds);
    }

    $(document).on("click", "#api-url-text", function (e) {
        var copyTextarea = document.querySelector('#api-url-text');
        copyTextarea.focus();
        copyTextarea.select();

        document.execCommand("copy");

        document.getSelection().removeAllRanges();

        $("#copied-msg").remove();
        if (!$("#copied-msg") || $("#copied-msg").length <= 0) {
            var copied_msg = $('<div id="copied-msg" style="float: right;background-color: rgb(255, 222, 173);padding: 5px 15px;color: black;font-weight: bold;"><span>Copied</span></div>');
            $("#api-url-text").after(copied_msg)
            hide_msg(copied_msg, 5000);
        }
    });

    // click on the Export Data tab
    $(document).on("click", "[href='#data']", function (e) {
        ga('send', 'event', 'Data Request', 'tab export');
    });

    // click on the API Access tab
    $(document).on("click", "[href='#api']", function (e) {
        ga('send', 'event', 'Data Request', 'tab api');
        //var apiMsg = getApiSamples();
        //$("#api-msg-panel").html("");
        //$("#api-msg-panel").append(apiMsg);
    });

    // click on the CSV File button under Export Data tab
    $(document).on("click", ".export-btn-csv", function (e) {
        e.preventDefault();
        //ga('send', 'event', 'Data Request', 'tab export', 'CSV click');
        downloadItem(this, 'csv');
    });

    // click on the JSON File button under Export Data tab
    $(document).on("click", ".export-btn-json", function (e) {
        e.preventDefault();
        //ga('send', 'event', 'Data Request', 'tab export', 'JSON click');
        downloadItem(this, 'json');
    });

    // click on the XML File button under Export Data tab
    $(document).on("click", ".export-btn-xml", function (e) {
        e.preventDefault();
        //ga('send', 'event', 'Data Request', 'tab export', 'XML click');
        downloadItem(this, 'xml');
    });

    // click on the Python tab inside API tab
    $(document).on("click", "tabs-api-python", function (e) {
        ga('send', 'event', 'Data Request', 'tab api', 'python inside API');
    });

    // click on the Excel tab inside API tab
    $(document).on("click", "tabs-api-excel", function (e) {
        ga('send', 'event', 'Data Request', 'tab api', 'excel inside API');
    });

    // click on the jQuery tab inside API tab
    $(document).on("click", "tabs-api-jquery", function (e) {
        ga('send', 'event', 'Data Request', 'tab api', 'jquery inside API');
    });

    // click on the R tab inside API tab
    $(document).on("click", "tabs-api-r", function (e) {
        ga('send', 'event', 'Data Request', 'tab api', 'R inside API');
    });

    // click on the NodeJS tab inside API tab
    $(document).on("click", "tabs-api-nodejs", function (e) {
        ga('send', 'event', 'Data Request', 'tab api', 'nodeJS inside API');
    });

    // click on the C# tab inside API tab
    $(document).on("click", "tabs-api-csharp", function (e) {
        ga('send', 'event', 'Data Request', 'tab api', 'CSharp inside API');
    });

    // click on the Java tab inside API tab
    $(document).on("click", "tabs-api-java", function (e) {
        ga('send', 'event', 'Data Request', 'tab api', 'java inside API');
    });

    // click on the PHP tab inside API tab
    $(document).on("click", "tabs-api-php", function (e) {
        ga('send', 'event', 'Data Request', 'tab api', 'PHP inside API');
    });

    var lock_download = false;

    function downloadItem(element, format) {

        if (lock_download)
            return;

        lock_download = true;

        // create a loader 
        var loading = $(loader);

        var experience = 1;

        var export_data_msg = $("#export-data-msg");

        // remove export message if any and insert the new one
        if (export_data_msg && export_data_msg.length > 0) {
            $("#export-msg-panel").remove();
            $("#export-data-msg").append(loading);
        } else {
            experience = 2;
        }

        // find the anchor element 
        if (!$(element).is('a')) {
            element = $(element).find('a')[0];
        }

        if (!element || element.length == 0 || !$(element).is('a')) {
            console.log('download link not found');
            return;
        }

        var url = $(element).attr('href');
        console.log('url to download = ' + url);

        var d_type = format;
        if (format == 'csv') {
            url = url.replace('format=csv', 'format=json');
            d_type = 'json';
        }

        $.ajax({
            url: url,
            type: "GET",
            dataType: d_type,
            xhrFields: {
                withCredentials: true
            },
        }).done(function (data, status, xhr) {
            console.log('SUCCESS');
            console.log('status = ' + xhr.status);
            console.log('data = ' + data.length);

            ga('send', 'event', 'Data Request', 'tab export', format, 1);

            var filename = buildFilename(url, format);

            downloadData(data, filename, format);

        }).fail(function (xhr, status, error) {
            console.log('ERROR');
            console.log('status = ' + xhr.status);
            console.log('error message = ' + xhr.responseText)

            ga('send', 'event', 'Data Request', 'tab export', format, 0);

            if (xhr.status) {
                switch (xhr.status) {
                    case 401: // unauthorized
                        launchInvalidKeyModal(experience);
                        break;
                    case 403: // forbidden
                        launchTrialOverModal(experience);
                        break;
                    case 400: // bad request
                        launchBadRequestModal(experience);
                        break;
                    case 409: // conflict (more requests per second than allowed)
                        launchThrottleModal(experience);
                        break;
                    default:
                        console.log('Unhandled status = ' + xhr.status)
                        var redirect_url = '';
                        if (TESymbol) {
                            redirect_url = 'https://data.tradingeconomics.com/Data/Export?term=' + TESymbol;
                        } else {
                            redirect_url = 'https://data.tradingeconomics.com/Data/Export';
                        }
                        console.log('redirecting to: ' + redirect_url);
                        window.open(redirect_url, '_blank');
                        break;
                }
            }
        }).always(function (xhr, status, error) {
            loading.remove();
            console.log('done downloading!');
            lock_download = false;
        });
    }

    function buildFilename(url, format) {
        var filename = decodeURI(url);

        filename = filename.replace("https://api.tradingeconomics.com/", "");

        var questionMark = filename.indexOf('?');
        if (questionMark != -1)
            filename = filename.substring(0, questionMark);

        filename = filename.replace(/\//g, '_');
        filename = filename.replace(/\s/g, '_');
        filename = filename.replace(/:/g, '_');
        filename = filename.replace(/-/g, '_');

        return filename + '.' + format;
    }

    function downloadData(data, filename, type) {
        var dataFile = null;

        switch (type) {
            case "csv":
                var csv = convertArrayOfObjectsToCSV({ data: data });
                if (csv == null) return;
                // create the csv file
                var dataFile = new Blob([csv], { type: "text/csv;charset=utf-8" });
                break;
            case "json":
                var dataFile = new Blob([JSON.stringify(data)], { type: "text/json;charset=utf-8" });
                //var dataStr = "data:text/json;charset=utf-8" + encodeURI(JSON.stringify(data));
                break;
            case "xml":
                var dataFile = new Blob([new XMLSerializer().serializeToString(data.documentElement)], { type: "text/plain;charset=utf-8" });
                //var dataStr = "data:text/plain;charset=utf-8," + new XMLSerializer().serializeToString(data.documentElement);
                break;
        }

        if (dataFile != null) {
            var anchor = document.createElement('a');
            anchor.href = window.URL.createObjectURL(dataFile);
            anchor.setAttribute("hidden", true);
            anchor.setAttribute("target", "_self");
            anchor.setAttribute("download", filename);

            document.body.appendChild(anchor);

            anchor.click();
            anchor.remove();
        }
    }

    /* Download CSV from: https://halistechnology.com/2015/05/28/use-javascript-to-export-your-data-as-csv/ */
    function convertArrayOfObjectsToCSV(args) {
        var result, ctr, keys, columnDelimiter, lineDelimiter, data;

        data = args.data || null;
        if (data == null || !data.length) {
            return null;
        }

        columnDelimiter = args.columnDelimiter || ',';
        lineDelimiter = args.lineDelimiter || '\r\n';

        keys = Object.keys(data[0]);

        result = '';
        result += keys.join(columnDelimiter);
        result += lineDelimiter;

        data.forEach(function (item) {
            ctr = 0;
            keys.forEach(function (key) {
                if (ctr > 0) result += columnDelimiter;

                result += item[key];
                ctr++;
            });
            result += lineDelimiter;
        });

        return result;
    }

    function launchTrialOverModal(experience) {
        if (!experience) {
            experience = getParameterByName("ex", window.location.href);
        }

        if (!experience || experience == 1) {
            var panel = createPanel(
                'ACTIVATE',
                'https://billing.tradingeconomics.com/plans.aspx?activate=true',
                'Activate your plan to get more data from Trading Economics',
                'account+limit');

            $("#export-data-msg").append(panel);
        } else if (experience == 2) {
            createModal(
                'ACTIVATE',
                'https://billing.tradingeconomics.com/plans.aspx?activate=true',
                'Activate your plan to get more data from Trading Economics',
                'account+limit');
        }
    }

    function launchInvalidKeyModal() {
        var experience = getParameterByName("ex", window.location.href);

        if (!experience || experience == 1) {
            var panel = createPanel(
                'Get Started',
                'https://billing.tradingeconomics.com/plans.aspx?lead=true',
                'Trading Economics provides its premium members with access to more than 20 million indicators for 196 countries plus historical/delayed/live quotes for exchange rates, stocks,' +
                    ' indexes, bonds and commodity prices. Subscribe to a plan to download data in a easy to use web interface, using our excel addin or our API.',
                'Subscription+Plans');

            $("#export-data-msg").append(panel);
        } else if (experience == 2) {
            createModal(
                'Get Started',
                'https://billing.tradingeconomics.com/plans.aspx?lead=true',
                'Trading Economics provides its premium members with access to more than 20 million indicators for 196 countries plus historical/delayed/live quotes for exchange rates, stocks,' +
                    ' indexes, bonds and commodity prices. Subscribe to a plan to download data in a easy to use web interface, using our excel addin or our API.',
                'Subscription+Plans');
        }
    }

    function launchThrottleModal() {
        var experience = getParameterByName("ex", window.location.href);

        if (!experience || experience == 1) {
            var panel = createPanel(
                null,
                null,
                'Limit of request per second reached',
                'API+Access');

            $("#export-data-msg").append(panel);
        } else if (experience == 2) {
            createModal(
                null,
                null,
                'Limit of request per second reached',
                'API+Access');
        }
    }

    function launchBadRequestModal() {
        var experience = getParameterByName("ex", window.location.href);

        if (!experience || experience == 1) {
            var panel = createPanel(
                'CONTACT SUPPORT',
                'https://tradingeconomics.com/contact.aspx?subject=API+Bad+Request',
                'Something went wrong with the request, please contact support@tradingeconomics.com, or click the button bellow',
                'API+Access');

            $("#export-data-msg").append(panel);
        } else if (experience == 2) {
            createModal(
                'CONTACT SUPPORT',
                'https://tradingeconomics.com/contact.aspx?subject=API+Bad+Request',
                'Something went wrong with the request, please contact support@tradingeconomics.com, or click the button bellow',
                'API+Access');
        }
    }

    function createModal(actionCallBtnText, actionCallBtnLink, text, contactSubject, title) {
        var htmlModal = `
                        <div class="modal fade modal-api" tabindex="-1" role="dialog" aria-labelledby="myModal" aria-hidden="true" style="text-align: center;padding: 0!important;">
	                        <div class ="modal-dialog modal-dialog-centered modal-lg" role="document" style="display: inline-block;text-align: left;vertical-align: middle; ">
	                            <div class="modal-content">
	                                <div class="modal-body">
	                                    <div class="container-fluid">
	                                        <div class="row mb-4" style="margin-bottom:15px;">
	                                            <div class="col text-center">`+
                                                    (title ? '<h3 class="modal-title text-center" id="exampleModalLongTitle">' + title + '</h3>' : '')
	                                            + `</div>
	                                        </div>
	                                        <div class="row mb-2" style="margin-bottom:15px;">
	                                            <div class ="col text-center"> `+
                                                    (text ? '<p>' + text + '</p>' : '')
                                                + `</div>
	                                        </div>
	                                        <div class="row mb-3" style="margin-bottom:15px;">
	                                            <div class="col text-center">`+
                                                    (actionCallBtnText ? '<a class="btn btn-secondary default-btn btn-lg" href="' + actionCallBtnLink + '" target="_blank" style="background-color: #333 !important; color: white;font-weight: 300;">' + actionCallBtnText + '</a>' : '')
	                                            + `</div>
	                                        </div>
	                                        <div class="row" style="margin-bottom:15px;">
	                                            <div class="col text-center">
	                                                <p>Any question? <strong><a href="https://tradingeconomics.com/contact.aspx?subject=` + contactSubject.split(' ').join('+') + `" target="_blank">Contact us</a></strong></p>
	                                            </div>
	                                        </div>
	                                    </div>
	                                </div>
	                            </div>
	                        </div>
	                    </div>
                        `

        // create the modal
        var modal = $(htmlModal);

        $(modal).modal('show');
    }

    function createPanel(actionCallBtnText, actionCallBtnLink, text, contactSubject, title) {
        var htmlPanel = `
                    <div id="export-msg-panel" style="padding:10px;" class="panel">
                        <div class="row mb-4" style="margin-bottom:15px;">
	                        <div class="col text-center">`+
                                (title ? '<h3 class="modal-title text-center" id="exampleModalLongTitle">' + title + '</h3>' : '')
	                        + `</div>
	                    </div>
	                    <div class="row mb-2" style="margin-bottom:15px;">
	                        <div class ="col text-center"> `+
                                (text ? '<p>' + text + '</p>' : '')
                            + `</div>
	                    </div>
	                    <div class="row mb-3" style="margin-bottom:15px;">
	                        <div class="col text-center">`+
                                (actionCallBtnText ? '<a class="btn btn-secondary default-btn btn-lg" href="' + actionCallBtnLink + '" target="_blank" style="background-color: #333 !important; color: white;font-weight: 300;">' + actionCallBtnText + '</a>' : '')
	                        + `</div>
	                    </div>
	                    <div class="row" style="margin-bottom:15px;">
	                        <div class="col text-center">
	                            <p>Any question? <strong><a href="https://tradingeconomics.com/contact.aspx?subject=` + contactSubject.split(' ').join('+') + `" target="_blank">Contact us</a></strong></p>
	                        </div>
	                    </div>
                    </div>`

        return htmlPanel;
    }

    function getParameterByName(name, url) {
        if (!url) url = window.location.href;
        name = name.replace(/[\[\]]/g, "\\$&");
        var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
            results = regex.exec(url);
        if (!results) return null;
        if (!results[2]) return '';
        return decodeURIComponent(results[2].replace(/\+/g, " "));
    }

    function getApiSamples(country, category) {
        var _country = '';
        var _category = '';
        var exportURL = '';

        if (country)
            _country = country.trim().toLowerCase();
        else if (TECountry)
            _country = TECountry.trim().toLowerCase();

        if (category)
            _category = category.trim().toLowerCase();
        else if (TECategory)
            _category = TECategory.trim().toLowerCase();

        var link = $('.export-btn-csv').attr('href');

        if (link) {
            if (link.indexOf('?format=csv') != -1)
                exportURL = link.replace('?format=csv', '');
            else
                exportURL = link.replace('&format=csv', '');

            var userKeyURL = exportURL.indexOf('?') != -1 ? '&c=Your_Key: Your_Secret' : '?c=Your_Key: Your_Secret';

            exportURL = exportURL + userKeyURL;
        }

        var apiCodeSamples = `
            <p><strong>API URL: </strong> <a href="`+ exportURL + `">` + exportURL + `</a></p>
            <p style="text-align:center;"><strong>Code examples: </strong></p>
                    <p><strong>Python:</strong></p>
                    <p style="margin-left:5%">
                        import tradingeconomics as te<br />
                        te.login('Your_Key:Your_Secret') <br />
                        te.getIndicatorData(country='`+ _country + `', indicators='` + _category + `') <br />
                    </p>
                    <p><strong>jQuery: </strong></p>
                    <p style="margin-left:5%">
                        var url = '`+ exportURL + `'; <br />
                        $.ajax({<br />
                        &nbsp&nbsp&nbsp&nbspurl: url, <br />
                        &nbsp&nbsp&nbsp&nbsptype: "GET", <br />
                        &nbsp&nbsp&nbsp&nbspdataType: 'json'<br />
                        }).done(function (data) {<br />
                                        &nbsp&nbsp&nbsp&nbspconsole.log(data); <br />
                        }); <br />
                    </p>`;

        return apiCodeSamples;
    }
</script>

<style>
    pre code {
        white-space: pre;
    }

    .modal-api:before {
        content: '';
        display: inline-block;
        height: 100%;
        vertical-align: middle;
        margin-right: -4px;
    }

    /* load spiner */
    .loader {
        border: 3px solid #f3f3f3;
        -webkit-animation: spin 1s linear infinite;
        animation: spin 1s linear infinite;
        border-top: 3px solid #555;
        border-radius: 50%;
    }

    @-webkit-keyframes spin {
        0% {
            -webkit-transform: rotate(0deg);
        }

        100% {
            -webkit-transform: rotate(360deg);
        }
    }

    @keyframes spin {
        0% {
            transform: rotate(0deg);
        }

        100% {
            transform: rotate(360deg);
        }
    }
    /* end load spiner */
</style>

<script>
    console.log("FEEDBACK LOADING");
    var feedback_uv = '<div style="float:top; box-shadow: rgba(255, 255, 255, 0.247059) 1px 1px 1px inset, rgba(0, 0, 0, 0.498039) 0px 0px 2px; font-style: normal; font-variant: normal; font-weight: bold; font-size: 14px; line-height: 1em; font-family: Arial, sans-serif; position: fixed; right: 0px; top: 35%; z-index: 9999; margin-top: 42px; background: 50% 0px no-repeat #E7E7E7;" class="uv-tab uv-slide-right ">'
    feedback_uv += '<a onClick="Feedback();return false;" style="background-color: transparent; display:block;padding:11px 12px 10px 6px;text-decoration:none;" href="javascript:return false;"><img src="https://d3fy651gv2fhd3.cloudfront.net/images/feedback-tab.png?t=Feedback&amp;c=00000&amp;r=-90" alt="Feedback" style="border:0; background-color: transparent; padding:0; margin:0;"></a>'
    feedback_uv += '</div>'
    $("body").append(feedback_uv)
    function Feedback() {
        var subject = window.location.pathname;
        if (subject.indexOf(":") > -1) subject += "%20market%20feedback";
        var redirectURL = "https://tradingeconomics.com/contact.aspx";
        redirectURL += "?subject=" + subject;
        window.open(redirectURL);
    }
</script>

<script src="https://d3fy651gv2fhd3.cloudfront.net/scripts/bloodhound.gr.js" type="text/javascript"></script>


    <script src="https://d3fy651gv2fhd3.cloudfront.net/scripts/te-standalone-ta.min.js?v=20180510b" type="text/javascript"></script>
    <script src="/scripts/search.1.0.0.js?v=20180510" type="text/javascript"></script>



<link rel="stylesheet" type="text/css" href="//cdnjs.cloudflare.com/ajax/libs/cookieconsent2/3.0.3/cookieconsent.min.css" />
<script src="//cdnjs.cloudflare.com/ajax/libs/cookieconsent2/3.0.3/cookieconsent.min.js"></script>
<script>
window.addEventListener("load", function(){
window.cookieconsent.initialise({
  "palette": {
    "popup": {
      "background": "#252e39"
    },
    "button": {
      "background": "#14a7d0"
    }
  },
  "position": "bottom-right",
  "content": {
    "message": "Trading Economics uses cookies to ensure you get the best experience on our website. ",
    "dismiss": "Dismiss",
    "link": "Learn More",
    "href": "https://tradingeconomics.com/privacy-policy.aspx"
  }
})});
</script>
    
<script>
        (function (i, s, o, g, r, a, m) {
            i['GoogleAnalyticsObject'] = r; i[r] = i[r] || function () {
                (i[r].q = i[r].q || []).push(arguments)
            }, i[r].l = 1 * new Date(); a = s.createElement(o),
            m = s.getElementsByTagName(o)[0]; a.async = 1; a.src = g; m.parentNode.insertBefore(a, m)
        })(window, document, 'script', '//www.google-analytics.com/analytics.js', 'ga');
        ga('create', 'UA-1982176-1', 'auto');
        ga('require', 'displayfeatures');

        if (typeof surveyExperiment != 'undefined' && typeof surveyVariation != 'undefined') {
            console.log('surveyExperiment', surveyExperiment, 'surveyVariation', surveyVariation);
            ga('set', 'exp', surveyExperiment + '.' + surveyVariation);
        }


        ga('send', 'pageview');

</script>
</body>
</html>
